#!/bin/csh -f

# ====================================================
# 
# Currently only works for ncsim
# 
#   source demo.sh [ncsim|vm|vm_auto]
#   source demo.sh -h
# ====================================================
# default values for langauge and simulator
set sim = ncsim
setenv APB `sn_which.sh shr_apb`
	

# parse arguments
while ($#argv > 0)
   switch ($1)
      case -h :
         echo "Script for running APB eVC demo"
         echo "Usage: source demo.sh  [ncsim|vm|vm_auto]"
         echo "       source demo.sh -h"
         exit 0
      case ncsim :
         set sim = ncsim
         breaksw
      case vm :
	 set sim = vm
	 breaksw
      case vm_auto :
         set sim = vm_auto
         breaksw
      case start_vsifs :
         set vm_auto_opt = $1
	 breaksw
      default :  
         echo "Usage: source demo.sh [ncsim|vm|vm_auto]"
         exit 1
   endsw
   shift
end
echo "Running APB demo with $sim simulator"

setenv package_name `sn_which.sh shr_apb`

#check that the APB eVC is correctly installed
if !(-f ${package_name}/PACKAGE_README.txt) then
   echo "APB eVC package is not correctly installed"
   echo "Possibly, SPECMAN_PATH not set properly"
   exit 1
endif


switch ($sim)
    case ncsim :
      `irun -top WORKLIB.TOP ${package_name}/examples/tb_apb2.vhd -snload shr_apb/examples/test_1.e -gui`
      breaksw
    case vm :
      cd `sn_which.sh shr_apb`/main_sve/vm
      ./run_idiot
      breaksw
    case vm_auto :
      cd `sn_which.sh shr_apb`/main_sve/vm
      ./run $vm_auto_opt shr_apb/main_sve/vm/shr_apb.vsif
      breaksw

    default:
      echo "Unknown simulator : $sim"
      exit 1
endsw



