Title        : coverage for APB eVC
Project      : APB eVC
File name    : shr_apb_bus_coverage.e
             :
Created On   : Tue Apr 1822:00:30 BST 2006
             :
Developers   : Adiel Khan, Cadence Design Systems
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------


<'
package shr_apb;

extend  shr_apb_bus_monitor_u {
   has_coverage: bool;
   keep soft has_coverage == TRUE;
   event tr_ended_bus_cover;
}; // extend  shr_apb...
'>

<'
extend has_coverage shr_apb_bus_monitor_u {
   on tr_ended {
      emit tr_ended_bus_cover;
   }; // on tr_ended
}; // extend shr_apb_...
'>
<'
extend has_coverage shr_apb_bus_monitor_u {
   //defines if transfer is ongoing
   !start_trans: bool;
   //measured in clock cycles
   !transfer_length: uint;
   //measured using sys.time
   !transfer_time: uint;
   
   on tr_ended {
      start_trans = FALSE;
      cur_transfer.end();
      transfer_time = cur_transfer.end_time - cur_transfer.start_time;
   }; // on transfer_end...   
   
   on tr_started {
      start_trans  =TRUE;
      start clock_cntr();
   }; // on transfer_sta...
   
   //count the clocks between transfer_start and transfer_end
   clock_cntr()@pclk_f is {
      transfer_length=0;
      while(start_trans){
         transfer_length=transfer_length+1;
         wait;
      }; // while(start_tra...
   }; // clock_cntr()@en...

   cover tr_ended_bus_cover using
     text = "generic transfer info" is {

      item bus_addr : shr_apb_address_t = cur_transfer.addr using
        text="all addresses",
        ranges = {
         range([0],"");         
         range([1..0xffff],"");
         range([0x10000..0xFFFFFFFF-1],"");
         range([0xFFFFFFFF],"");
        }; // ranges =

//      item bus_addr : shr_apb_address_t = cur_transfer.addr using
//        text="transfer addr (ADDR) for > 15", ignore = (bus_addr >15),
//        ranges = {
//         range([0..15],"",1);
//      }; //

      item bus_direction : shr_apb_direction_t = cur_transfer.direction using
        text="transfer direction";

      cross bus_addr, bus_direction using name = addresses_with_RW;
    
      item slave_device :shr_apb_slave_id_t=cur_transfer.slave_number
        using per_instance,ignore=(slave_device==UNDEFINED); // Collect separately for each master
     
      item transfer_length using 
        text="transfer clk cycles from start to finish",
        ranges = {
         range([0],"");
         range([1..15],"",1);
         range([16..32],"",4);
         range([32..0xFFFFFFFF],"");
      };
      item transfer_time using 
        text="transfer time from start to finish",
        ranges = {
         range([0],"");
         range([1..32],"",2);
         range([32..128],"",4);
         range([129..0xFFFFFFFF],"");
      };
            
      item bus_data : shr_apb_data_t =cur_transfer.data using 
        text="Transfer data (DATA)",
        ranges = {
         range([0],"");         
         range([1..0xffff],"");
         range([0x10000..0xFFFFFFFF-1],"");
         range([0xFFFFFFFF],"");
      }; //
            
      transition bus_addr using 
        name = transition__bus_addr;
      transition bus_direction using 
        name = transition__bus_direction;
      cross transition__bus_direction, transfer_length using 
        name = clk_latency_vs_direction;
      cross transition__bus_direction, transfer_time using 
        name = time_latency_vs_direction;
      cross transition__bus_direction,transition__bus_addr using 
        name = direction_vs_addr;
      cross clk_latency_vs_direction,direction_vs_addr using 
        name=clk_latency_vs_direction_vs_addr;
      cross time_latency_vs_direction,direction_vs_addr using 
        name=time_latency_vs_direction_vs_addr;
      cross bus_direction,bus_addr,bus_data using 
        name =cover_transfer;
   }; //

}; // extend has_cove...

'>
