Title        : coverage for APB eVC
Project      : APB eVC
File name    : shr_apb_seq_coverage.e
             :
Created On   : Tue Apr 1822:00:30 BST 2006
             :
Developers   : Adiel Khan, Cadence Design Systems
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

  Examples for:
  
  1) Basic coverage collection:
  2) Cover on a user event
  3) Add items to the cover
  4) Ignore some sequence kinds

  Basic coverage collection:

<'
package shr_apb;

cover_sequence shr_apb_sequence;
'>


  Cover on a user event


cover_sequence shr_apb_sequence using vr_spi_cover_event;

extend shr_apb_sequence {
    event shr_apb_cover_event;
    
    postponed_coverage() @driver.clock is {
        #wait [10] * cycle;
        emit shr_apb_cover_event;
    };
    
    post_body() @driver.clock is also {
        start postponed_coverage();
    };
    
};


  

  Add items to the cover

  Cover also the cell.legal field of the shr_apb_sequence


extend shr_apb_sequence {
    cover cover_seq is also {
        item legal_cell : bool = (cell != NULL ? cell.legal : FALSE);
    };
};



  Ignore some sequence kinds

  Ignore shr_apb_sequence MAIN, SIMPLE and RANDOM sequences


extend shr_apb_sequence {
    cover cover_seq is also {
        item kind using also 
          ignore = ( (kind == RANDOM) or (kind == MAIN) or (kind == SIMPLE));
    }; 
};






extend sys {
    setup() is also {
       specman("trace seq");
    }; 
}; 
