Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_env.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- Import the apb eVC
import shr_apb/e/shr_apb_top;

-- Create a logical name for the eVC instance. 
extend shr_apb_bus_name_t : [APB0];


-- Instantiate the eVC under sys.
extend sys {
    apb_evc0 : APB0 ACTIVE shr_apb_env_u is instance;
};

-- Configure the eVC instance. This section sets up how the eVC accesses
-- signals in the DUT.
extend APB0 shr_apb_signal_map_u {  
    keep APB_PCLK       ==  "clock";	// clock	
    keep APB_PRESETn    ==  "rst";	        // reset (active low)
    keep APB_PWDATA     ==  "wdata";	        // 32-bit write data bus
    keep APB_PRDATA     ==  "rdata";	        // 32-bit read data bus
    keep APB_PADDR      ==  "addr";	        	
    keep APB_PWRITE     ==  "write";	        // transfer direction
    keep APB_PENABLE	==  "enable";
};

extend shr_apb_slave_signal_map_u {
    keep soft APB_PSEL       ==  appendf("%s%d","hsel",id);   
};

-- Create a logical name for each agent in the bus (including those supplied
-- by the eVC and those supplied by the DUT (and therefore shadowed by the
-- eVC). 

extend shr_apb_agent_name_t : [BRIDGE_0, 
                               SLAVE_0, 
                               SLAVE_1,
                               SLAVE_2];

-- Instantiate the agents under the eVC instances
extend shr_apb_env_u {
    keep hdl_path()     == "top";
    keep soft active_bridge_name    == BRIDGE_0;
    keep passive_slave_names  == {};
    keep active_slave_names.size() == 16;
        
    -- This instance of the eVC has a protocol checker
    keep has_protocol_checker == TRUE;
};

'>
o Reset issues:

<'
extend sys {
   setup() is also {
      set_config(print, radix, hex);
   };
}; // extend sys

extend shr_apb_env_u {  
   event apb_clock is rise(smp.sig_pclk$) @sim;

   drive_reset() @apb_clock is {
      smp.sig_presetn$ = 0;
      smp.sig_penable$ = 0;
      message(LOW, "Driving APB presetn LOW");
      message(LOW, "Driving APB penable LOW");
      wait [5] * cycle;
      wait delay(10);
      smp.sig_presetn$ = 1;
      message(LOW, "Driving APB reset HIGH");

      for each in ssmp {
         .sig_psel$ = 0;
         message(LOW, "Driving APB psel LOW");
      }; // for each in ssm...
   };
   
   run() is also {
      start drive_reset();
   };
};

'>    
