Title        : Top level env unit for eVC
Project      : APB eVC
File name    : shr_apb_env.e
             :
Created On   : 22/04/2002
             :
Developers   : Patrick Oury, Verisity EURL
             :
Purpose      : 
             :
Description  : 
             :
Assumptions  : none
             :
Limitations  : none
             :
Known Errors : none
             :
Notes        : 

----------------------------------------------------------------------------
Revision History :
----------------------------------------------------------------------------

<'

-- Import the apb eVC
import shr_apb/e/shr_apb_top;

-- Create a logical name for the eVC instance. 
extend shr_apb_bus_name_t : [APB];

extend shr_apb_driver_u {
  keep bfm_interaction_mode == PUSH_MODE;
};

-- Instantiate the eVC under sys.
extend sys {
    apb_evc0 : APB ACTIVE shr_apb_env_u is instance;
};

-- Configure the eVC instance. This section sets up how the eVC accesses
-- signals in the DUT.
extend APB shr_apb_signal_map_u {  
    keep APB_PCLK       ==  "clock";     	// clock	
    keep APB_PRESETn    ==  "rst";	        // reset (active low)
    keep APB_PWDATA     ==  "wdata";	        // 32-bit write data bus
    keep APB_PRDATA     ==  "rdata";	        // 32-bit read data bus
    keep APB_PADDR      ==  "addr";	        	
    keep APB_PWRITE     ==  "write";	        // transfer direction
    keep APB_PENABLE	==  "enable";
};

extend shr_apb_slave_signal_map_u {
//   keep APB_PSEL == "hsel0";
    keep soft APB_PSEL       ==  appendf("%s%d","hsel",id);   
};

-- Create a logical name for each agent in the bus (including those supplied
-- by the eVC and those supplied by the DUT (and therefore shadowed by the
-- eVC). 

extend shr_apb_agent_name_t : [BRIDGE_0, 
                               SLAVE_0];

-- Instantiate the agents under the eVC instances
extend shr_apb_env_u {
    keep hdl_path()     == "top";
    keep soft active_bridge_name    == BRIDGE_0;
    keep active_slave_names  == {S0};
    keep active_slave_names.size() == 1;
        
    -- This instance of the eVC has a protocol checker
    keep has_protocol_checker == TRUE;
};

'>


o Reset issues:

<'
extend sys {
    setup() is also {
        set_config(print, radix, hex);
    };
    
    // This is a temporary workaround for reset due to the fact that 
    // the eRM guideline for reset is not yet completed
    event apb_clock is rise('top/clock') @sim;
    drive_reset() @apb_clock is {
        'spi_wrapper/rst' = 1;
        wait [5] * cycle;
        wait delay(1);
       'spi_wrapper/rst' = 0;
    };
    
    run() is also {
        start drive_reset();
    };
};
'>
